Skip to main content
`Ctrl`+`K`

# TSSetSolutionFunction

Provide a function that computes the solution of the ODE or DAE

## Synopsis

    #include "petscts.h"
    PetscErrorCode TSSetSolutionFunction(TS ts, TSSolutionFn *f, void *ctx)

Logically Collective

## Input Parameters

- ts - the `TS` context obtained from `TSCreate()`

- f - routine for evaluating the solution

- ctx - [optional] user-defined context for private data for the function evaluation routine (may be `NULL`)

## Options Database Keys

- -ts_monitor_lg_error - create a graphical monitor of error history, requires user to have provided `TSSetSolutionFunction()`

- -ts_monitor_draw_error - Monitor error graphically, requires user to have provided `TSSetSolutionFunction()`

## Notes

This routine is used for testing accuracy of time integration schemes when you already know the solution. If analytic solutions are not known for your system, consider using the Method of Manufactured Solutions to create closed-form solutions with non-physical forcing terms.

For low-dimensional problems solved in serial, such as small discrete systems, `TSMonitorLGError()` can be used to monitor the error history.

## See Also

TS: Scalable ODE and DAE Solvers, `TS`, `TSSolutionFn`, `TSSetRHSJacobian()`, `TSSetIJacobian()`, `TSComputeSolutionFunction()`, `TSSetForcingFunction()`, `TSSetSolution()`, `TSGetSolution()`, `TSMonitorLGError()`, `TSMonitorDrawError()`

## Level

intermediate

## Location

src/ts/interface/ts.c

## Examples

src/tao/unconstrained/tutorials/spectraladjointassimilation.c
src/ts/tutorials/ex43.c
src/ts/tutorials/ex50.c

Index of all TS routines
Table of Contents for all manual pages
Index of all manual pages